SystemOrganization addCategory: #'DAO-TP-Changes'!

Error subclass: #UnidadDeTrabajoException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

TestCase subclass: #ChangesTest
	instanceVariableNames: 'diccionarioDeAcciones nombreDelAutor fechaYHoraTest registroDePruebaC1 registroDePruebaC2 registroDePruebaC3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ChangesTest class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:06'!
mensajeTest
	^self.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 22:42'!
algunaUnidadDeTrabajo
	^UnidadDeTrabajoInicial  new.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:05'!
autorTest
	^self.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:05'!
class: aClass recategorizedFrom: oldCategory to: newCategory
	(diccionarioDeAcciones at: ClassRecategorized) value: (ClassRecategorized class: aClass recategorizedFrom: oldCategory to: newCategory).
! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:05'!
classAdded: aClass inCategory: aCategoryName 
	(diccionarioDeAcciones at: ClassAdded) value: (ClassAdded class: aClass category: aCategoryName).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:05'!
classCategoryAdded: unNombreDeCategoria 
	(diccionarioDeAcciones at: CategoryAdded) value: (CategoryAdded categoryName: unNombreDeCategoria).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:05'!
classCategoryRemoved: unNombreDeCategoria 
	(diccionarioDeAcciones at: CategoryRemoved) value: (CategoryRemoved categoryName: unNombreDeCategoria).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:05'!
classCategoryRenamedFrom: anOldClassCategoryName to: aNewClassCategoryName
	(diccionarioDeAcciones at: CategoryRenamed ) value: (CategoryRenamed classCategoryRenamedFrom: anOldClassCategoryName to: aNewClassCategoryName).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:05'!
classDefinitionChangedFrom: aBlahClass to: aBlahClass2 
	(diccionarioDeAcciones at: ClassModifiedClassDefinition) value:  (ClassModifiedClassDefinition classDefinitionChangedFrom: aBlahClass to: aBlahClass2)! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:05'!
classRemoved: aClass fromCategory: aCategoryName
	( diccionarioDeAcciones at: ClassRemoved ) value: (ClassRemoved class: aClass category: aCategoryName).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:05'!
fullName
	^nombreDelAutor.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:05'!
fullName: unNombreDelAutor 
	nombreDelAutor := unNombreDelAutor.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:05'!
initialize 
	diccionarioDeAcciones := Dictionary new.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:05'!
methodAdded: aMethod selector: aSymbol inProtocol: aCategoryName class: aClass requestor: requestor
	(diccionarioDeAcciones at: MethodAdded ) value: (MethodAdded method: aMethod selector: aSymbol protocol: aCategoryName class: aClass requestor: requestor).
	
	
! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:05'!
methodChangedFrom: oldMethod to: newMethod selector: aSelector inClass: aClass oldProtocol: oldProtocol newProtocol: newProtocol requestor: anUndefinedObject 
	(diccionarioDeAcciones at: MethodModified ) value: (
		MethodModified	methodChangedFrom: oldMethod
							to: newMethod
							selector: aSelector 
							inClass: aClass
							oldProtocol: oldProtocol
							newProtocol: newProtocol
							requestor: anUndefinedObject
						).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:05'!
methodRemoved: aMethod selector: aSymbol inProtocol: protocol class: aClass origin: anOrigin
	(diccionarioDeAcciones at: MethodRemoved ) value: (MethodRemoved methodRemoved: aMethod selector: aSymbol protocol: protocol class: aClass origin: anOrigin).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:06'!
now
	^fechaYHoraTest.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:06'!
on: unTipoDeEvento do: aBlockClosure 
	
	diccionarioDeAcciones at: unTipoDeEvento put: aBlockClosure.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:06'!
registroClassCreatedC1
	"Este mensaje nos devuelve un registro para que guarde el sistema de cambios"
	| cambioDePrueba |
	registroDePruebaC1 ifNil: [ 
		cambioDePrueba := ClassCreatedChange class: 'C1' category: 'nombre de la categoria'. 
		registroDePruebaC1 := RegistroDeCambio newWithThischange: cambioDePrueba andThisAuthor: 'Sebas' atThisTime: self now . 
	]. 
	
	^registroDePruebaC1.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:06'!
registroClassCreatedC2
	"Este mensaje nos devuelve un registro para que guarde el sistema de cambios"
	| cambioDePrueba |
	registroDePruebaC2 ifNil: [ 
		cambioDePrueba := ClassCreatedChange class: 'C2' category: 'nombre de la categoria'. 
		registroDePruebaC2 := RegistroDeCambio newWithThischange: cambioDePrueba andThisAuthor: 'Sebas' atThisTime: self now . 
	]. 
	
	^registroDePruebaC2.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:06'!
registroClassCreatedC3
	"Este mensaje nos devuelve un registro para que guarde el sistema de cambios"
	| cambioDePrueba |
	registroDePruebaC3 ifNil: [ 
		cambioDePrueba := ClassCreatedChange class: 'C3' category: 'nombre de la categoria'. 
		registroDePruebaC3 := RegistroDeCambio newWithThischange: cambioDePrueba andThisAuthor: 'Sebas' atThisTime: self now . 
	]. 
	
	^registroDePruebaC3.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:06'!
registroClassMethodCreatedC1
	| cambioDePrueba |
	registroDePruebaC1 ifNil: [ 
		cambioDePrueba := ClassMethodCreatedChange classAffected: 'ChangesTest' methodName: 'now' methodCategory: 'as yet unclassified' sourceCode: '^self'.
		registroDePruebaC1 := RegistroDeCambio newWithThischange: cambioDePrueba andThisAuthor: 'Sebas' atThisTime: self now . 
	]. 
	
	^registroDePruebaC1.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:06'!
registroInstanceMethodCreatedC1
	| cambioDePrueba |
	registroDePruebaC1 ifNil: [ 
		cambioDePrueba := InstanceMethodCreatedChange classAffected: 'ChangesTest' methodName: 'now' methodCategory: 'as yet unclassified' sourceCode: '^self'.
		registroDePruebaC1 := RegistroDeCambio newWithThischange: cambioDePrueba andThisAuthor: 'Sebas' atThisTime: self now . 
	]. 
	
	^registroDePruebaC1.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:06'!
relojTest
	^self.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:06'!
selector: aSelector recategorizedFrom: aNewProtocol to: anOldProtocol inClass: aClass 
	(diccionarioDeAcciones at: MethodRecategorized) value: (MethodRecategorized method: (aClass compiledMethodAt: aSelector ifAbsent: [nil]) selector: aSelector class: aClass newProtocol: anOldProtocol oldProtocol: aNewProtocol  ).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:06'!
setear: aDateAndTime 
	fechaYHoraTest := aDateAndTime.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:06'!
test01
	self assert:(true).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:06'!
unSystemAnnouncer
	^self.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 23:06'!
unaInterfaceDeEventosDeEntradaInicializada
	| unAutor unReloj unSistemaDeCambios |
	unReloj := self relojTest.
	unAutor := self autorTest.
	unSistemaDeCambios := SistemaDeCambios new.
	unAutor fullName: 'Seba'.
	unReloj setear: DateAndTime now.
	^InterfaceDeEntradaDelSistemaDeCambios newWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj! !

ChangesTest subclass: #InerfazDeEntradaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:33'!
test01ClassCategoryCreated

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada classCategoryCreated: #'DAO-TP-Changes'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio categoryName = #'DAO-TP-Changes').
		self assert: (unRegistroDeCambio cambio evento = ClassCategoryCreatedChange evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:33'!
test02ClassCategoryRemoved

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada classCategoryRemoved: #'DAO-TP-Changes'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio categoryName = #'DAO-TP-Changes').
		self assert:(unRegistroDeCambio cambio evento = ClassCategoryRemovedChange evento)
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:34'!
test03ClassCategoryRemoved

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada classCategoryRenamedFrom: #'DAO-TP-Changes' to: #'DAO-TP-Changes2'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio oldCategoryName  = #'DAO-TP-Changes').
		self assert: (unRegistroDeCambio cambio newCategoryName  = #'DAO-TP-Changes2').
		self assert: (unRegistroDeCambio cambio evento = ClassCategoryRenamedChange evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:34'!
test04ClassCreated

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada classCreated: #'ChangesTest' inCategory: #'DAO-TP-Changes'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio classCreated = #'ChangesTest').
		self assert: (unRegistroDeCambio cambio classCategory = #'DAO-TP-Changes').
		self assert: (unRegistroDeCambio cambio evento = ClassCreatedChange evento)
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:34'!
test05ClassRemoved

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada classRemoved: #'ChangesTest' fromCategory: #'DAO-TP-Changes'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio classRemoved = #'ChangesTest').
		self assert: (unRegistroDeCambio cambio classCategory = #'DAO-TP-Changes').
		self assert: (unRegistroDeCambio cambio evento = ClassRemovedChange evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:35'!
test06ClassRecategorized

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada classRecategorized: #'ChangesTest' fromCategory: #'DAO-TP-Changes' toCategory: #'DAO-TP-Changes2'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio classRecategorized = #'ChangesTest').
		self assert: (unRegistroDeCambio cambio oldCategory = #'DAO-TP-Changes').
		self assert: (unRegistroDeCambio cambio newCategory = #'DAO-TP-Changes2').
		self assert: (unRegistroDeCambio cambio evento = ClassRecategorizedChange evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:35'!
test07SuperClassChanged

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada superclassChangedOn: #'ChangesTest' from: #'Object' to: #'TestCase'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio classAffected = #'ChangesTest').
		self assert: (unRegistroDeCambio cambio oldSuperclass = #'Object').
		self assert: (unRegistroDeCambio cambio newSuperclass = #'TestCase').
		self assert: (unRegistroDeCambio cambio evento = SuperclassChangedChange evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:35'!
test08ClassMethodCategoryCreated

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada classMethodCategoryCreated: #'as yet unclassified'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio categoryName = #'as yet unclassified').
		self assert: (unRegistroDeCambio cambio evento = ClassMethodCategoryCreatedChange evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:36'!
test13InstanceVariableCreated

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada instanceVariableCreatedOn: #'ChangesTest' named: #'hola'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio classAffected = #'ChangesTest').
		self assert: (unRegistroDeCambio cambio variableName = #'hola').
		self assert: (unRegistroDeCambio cambio evento = InstanceVariableCreatedChange evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:36'!
test14InstanceVariableRemoved

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada instanceVariableRemovedFrom: #'ChangesTest' named: #'hola'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio classAffected = #'ChangesTest').
		self assert: (unRegistroDeCambio cambio variableName = #'hola').
		self assert: (unRegistroDeCambio cambio evento = InstanceVariableRemovedChange evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:37'!
test15ClassInstanceVariableCreated

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada classInstanceVariableCreatedOn: #'ChangesTest' named: #'hola'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio classAffected = #'ChangesTest').
		self assert: (unRegistroDeCambio cambio variableName = #'hola').
		self assert: (unRegistroDeCambio cambio evento = ClassInstanceVariableCreatedChange  evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:37'!
test16ClassInstanceVariableRemoved

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada classInstanceVariableRemovedFrom: #'ChangesTest' named: #'hola'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio classAffected = #'ChangesTest').
		self assert: (unRegistroDeCambio cambio variableName = #'hola').
		self assert: (unRegistroDeCambio cambio evento = ClassInstanceVariableRemovedChange evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:37'!
test17ClassVariableCreated

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada classVariableCreatedOn: #'ChangesTest' named: #'hola'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio classAffected = #'ChangesTest').
		self assert: (unRegistroDeCambio cambio variableName = #'hola').
		self assert: (unRegistroDeCambio cambio evento = ClassVariableCreatedChange  evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:38'!
test18ClassVariableRemoved

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada classVariableRemovedFrom: #'ChangesTest' named: #'hola'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio classAffected = #'ChangesTest').
		self assert: (unRegistroDeCambio cambio variableName = #'hola').
		self assert: (unRegistroDeCambio cambio evento = ClassVariableRemovedChange evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:38'!
test21ClassMethodCreated

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada classMethod: #'funcion' createdOn: #'ChangesTest' inCategory: #'as yet unclassified' withCode: #'^147'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio classAffected = #'ChangesTest').
		self assert: (unRegistroDeCambio cambio methodName = #'funcion').
		self assert: (unRegistroDeCambio cambio methodCategory = #'as yet unclassified').
		self assert: (unRegistroDeCambio cambio sourceCode = #'^147').
		self assert: (unRegistroDeCambio cambio evento = ClassMethodCreatedChange evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:38'!
test22ClassMethodRemoved

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada classMethod: #'funcion' removedFrom: #'ChangesTest' inCategory: #'as yet unclassified' withCode: #'^147'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio classAffected = #'ChangesTest').
		self assert: (unRegistroDeCambio cambio methodName = #'funcion').
		self assert: (unRegistroDeCambio cambio methodCategory = #'as yet unclassified').
		self assert: (unRegistroDeCambio cambio sourceCode = #'^147').
		self assert: (unRegistroDeCambio cambio evento = ClassMethodRemovedChange evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:39'!
test23ClassMethodRecategorized

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada classMethod: #'funcion' onClass: #'ChangesTest' recategorizedFrom: #'as yet unclassified' to: #'as yet unclassified2'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio classAffected = #'ChangesTest').
		self assert: (unRegistroDeCambio cambio methodName = #'funcion').
		self assert: (unRegistroDeCambio cambio oldMethodCategory = #'as yet unclassified').
		self assert: (unRegistroDeCambio cambio newMethodCategory = #'as yet unclassified2').
		self assert: (unRegistroDeCambio cambio evento = ClassMethodRecategorizedChange evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:39'!
test24ClassMethodChanged

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada classMethodChanged: #'funcion' onClass: #'ChangesTest' oldSourceCode: '^self' newSourceCode: '^444'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio classAffected = #'ChangesTest').
		self assert: (unRegistroDeCambio cambio methodName = #'funcion').
		self assert: (unRegistroDeCambio cambio oldSourceCode = '^self').
		self assert: (unRegistroDeCambio cambio newSourceCode = '^444').
		self assert: (unRegistroDeCambio cambio evento = ClassMethodChangedChange evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:40'!
test25InstanceMethodCreated

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada instanceMethod: #'funcion' createdOn: #'ChangesTest' inCategory: #'as yet unclassified' withCode: #'^147'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio classAffected = #'ChangesTest').
		self assert: (unRegistroDeCambio cambio methodName = #'funcion').
		self assert: (unRegistroDeCambio cambio methodCategory = #'as yet unclassified').
		self assert: (unRegistroDeCambio cambio sourceCode = #'^147').
		self assert: (unRegistroDeCambio cambio evento = InstanceMethodCreatedChange evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:40'!
test26InstanceMethodRemoved

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada instanceMethod: #'funcion' removedFrom: #'ChangesTest' inCategory: #'as yet unclassified' withCode: #'^147'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio classAffected = #'ChangesTest').
		self assert: (unRegistroDeCambio cambio methodName = #'funcion').
		self assert: (unRegistroDeCambio cambio methodCategory = #'as yet unclassified').
		self assert: (unRegistroDeCambio cambio sourceCode = #'^147').
		self assert: (unRegistroDeCambio cambio evento = InstanceMethodRemovedChange evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:40'!
test27InstanceMethodRecategorized

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada instanceMethod: #'funcion' onClass: #'ChangesTest' recategorizedFrom: #'as yet unclassified' to: #'as yet unclassified2'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio classAffected = #'ChangesTest').
		self assert: (unRegistroDeCambio cambio methodName = #'funcion').
		self assert: (unRegistroDeCambio cambio oldMethodCategory = #'as yet unclassified').
		self assert: (unRegistroDeCambio cambio newMethodCategory = #'as yet unclassified2').
		self assert: (unRegistroDeCambio cambio evento = InstanceMethodRecategorizedChange evento).
		]! !

!InerfazDeEntradaTest methodsFor: '05InterfazDeEntrada' stamp: 'SebastianGarbi 10/13/2013 22:41'!
test28InstanceMethodChanged

	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada instanceMethodChanged: #'funcion' onClass: #'ChangesTest' oldSourceCode: '^self' newSourceCode: '^444'.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio classAffected = #'ChangesTest').
		self assert: (unRegistroDeCambio cambio methodName = #'funcion').
		self assert: (unRegistroDeCambio cambio oldSourceCode = '^self').
		self assert: (unRegistroDeCambio cambio newSourceCode = '^444').
		self assert: (unRegistroDeCambio cambio evento = InstanceMethodChangedChange evento).
		]! !

ChangesTest subclass: #InerfazDeUsuarioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InerfazDeUsuarioTest methodsFor: '04InterfazDeUsuario' stamp: 'SebastianGarbi 10/13/2013 21:37'!
test510LaInterfazDeUsusarioPuedeCerrarLaUnidadActiva
 | unSistemaDeCambios  unaInterfazDeUsuario |

 unSistemaDeCambios := SistemaDeCambios new.   

 unaInterfazDeUsuario := InterfazDeUsuario newWith: unSistemaDeCambios.
 unaInterfazDeUsuario cerrarUnidad.
 
 self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.! !

!InerfazDeUsuarioTest methodsFor: '04InterfazDeUsuario' stamp: 'SebastianGarbi 10/13/2013 22:12'!
test515LaInterfazDeUsusarioPuedePreguntarTodosLosCambiosRealizados
 | unSistemaDeCambios  unaInterfazDeUsuario unRegistroDeCambio |

 unSistemaDeCambios := SistemaDeCambios new.   
 unaInterfazDeUsuario := InterfazDeUsuario newWith: unSistemaDeCambios.
 
unRegistroDeCambio := self registroClassCreatedC1.
 
self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
self assert: unaInterfazDeUsuario todosLosCambios size = 0.
unSistemaDeCambios registrarCambio: unRegistroDeCambio.

unaInterfazDeUsuario cerrarUnidad.
unSistemaDeCambios registrarCambio: unRegistroDeCambio.

unaInterfazDeUsuario cerrarUnidad.
 
 self assert: unSistemaDeCambios unidadesDeTrabajo size = 2.
 self assert: unaInterfazDeUsuario todosLosCambios size = 2.
! !

!InerfazDeUsuarioTest methodsFor: '04InterfazDeUsuario' stamp: 'SebastianGarbi 10/13/2013 22:13'!
test520LaInterfazDeUsusarioPuedePreguntarTodosLosCambiosRealizadosDeUnMetodoDeClase
 | unSistemaDeCambios  unaInterfazDeUsuario unRegistroDeCambio |

 unSistemaDeCambios := SistemaDeCambios new.   

 unaInterfazDeUsuario := InterfazDeUsuario newWith: unSistemaDeCambios.

" unCambio := (ClassCreatedChange newAffectedClassName: 'ChangesTest' categoryName: 'DAO-TP-Changes').
 unRegistroDeCambio := RegistroDeCambio newWithThischange: unCambio andThisAuthor: 'Seba' atThisTime: DateAndTime now."
 unRegistroDeCambio := self registroClassCreatedC1.

 self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
 self assert: unaInterfazDeUsuario todosLosCambios size = 0.

 unSistemaDeCambios registrarCambio: unRegistroDeCambio.
 unaInterfazDeUsuario cerrarUnidad.
 
 unSistemaDeCambios registrarCambio: unRegistroDeCambio.
 unaInterfazDeUsuario cerrarUnidad.
 
 self assert: unSistemaDeCambios unidadesDeTrabajo size = 2.
 self assert: unaInterfazDeUsuario todosLosCambios size = 2.
 self assert: (unaInterfazDeUsuario todosLosCambiosDelMensajeDeClase: 'now' deLaClase: 'ChangesTest' ) size = 0.
! !

!InerfazDeUsuarioTest methodsFor: '04InterfazDeUsuario' stamp: 'SebastianGarbi 10/13/2013 22:21'!
test521LaInterfazDeUsusarioPuedePreguntarTodosLosCambiosRealizadosDeUnMetodoDeClase
 | unSistemaDeCambios  unaInterfazDeUsuario unRegistroDeCambio |

 unSistemaDeCambios := SistemaDeCambios new.   

 unaInterfazDeUsuario := InterfazDeUsuario newWith: unSistemaDeCambios.
" unCambio := ClassMethodCreatedChange
								onClass: 'ChangesTest'
								selector: 'now'
								protocol: 'as yet unclassified'
								sourceCode: 'now'.

(ClassCreatedChange newAffectedClassName: 'ChangesTest' categoryName: 'DAO-TP-Changes').
 unRegistroDeCambio := RegistroDeCambio newWithThischange: unCambio andThisAuthor: 'Seba' atThisTime: DateAndTime now."
unRegistroDeCambio := self registroClassMethodCreatedC1.

 self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
 self assert: unaInterfazDeUsuario todosLosCambios size = 0.

 unSistemaDeCambios registrarCambio: unRegistroDeCambio.
 unaInterfazDeUsuario cerrarUnidad.
 
 unSistemaDeCambios registrarCambio: unRegistroDeCambio.
 unaInterfazDeUsuario cerrarUnidad.
 
 self assert: unSistemaDeCambios unidadesDeTrabajo size = 2.
 self assert: unaInterfazDeUsuario todosLosCambios size = 2.
 self assert: (unaInterfazDeUsuario todosLosCambiosDelMensajeDeClase: 'now' deLaClase: 'ChangesTest' ) size = 2.
! !

!InerfazDeUsuarioTest methodsFor: '04InterfazDeUsuario' stamp: 'SebastianGarbi 10/13/2013 22:25'!
test531LaInterfazDeUsusarioPuedePreguntarTodosLosCambiosRealizadosDeUnMetodoDeInstancia
 | unSistemaDeCambios  unaInterfazDeUsuario unRegistroDeCambio |

 unSistemaDeCambios := SistemaDeCambios new.   

 unaInterfazDeUsuario := InterfazDeUsuario newWith: unSistemaDeCambios.
" unCambio := InstanceMethodCreatedChange
								onClass: 'ChangesTest'
								selector: 'now'
								protocol: 'as yet unclassified'
								sourceCode: 'now'.

 unRegistroDeCambio := RegistroDeCambio newWithThischange: unCambio andThisAuthor: 'Seba' atThisTime: DateAndTime now.
"
unRegistroDeCambio := self registroInstanceMethodCreatedC1 .
 self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
 self assert: unaInterfazDeUsuario todosLosCambios size = 0.

 unSistemaDeCambios registrarCambio: unRegistroDeCambio.
 unaInterfazDeUsuario cerrarUnidad.
 
 unSistemaDeCambios registrarCambio: unRegistroDeCambio.
 unaInterfazDeUsuario cerrarUnidad.
 
 self assert: unSistemaDeCambios unidadesDeTrabajo size = 2.
 self assert: unaInterfazDeUsuario todosLosCambios size = 2.
 self assert: (unaInterfazDeUsuario todosLosCambiosDelMensajeDeInstancia: 'now' deLaClase: 'ChangesTest' ) size = 2.
! !

ChangesTest subclass: #InterfazDeEventosDeEntradaTest
	instanceVariableNames: 'diccionarioDeAcciones nombreDelAutor fechaYHoraTest registroDePruebaC1 registroDePruebaC2 registroDePruebaC3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test010ElSistemaDebeCrearUnaUnidadCuandoLaActualEsteCerradaYSeRegistreUnCambio
	| unSistemaDeCambios unaInterfaceDeEventosDeEntrada unCambio |

	unaInterfaceDeEventosDeEntrada:= self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
			
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	unCambio := ClassCreatedChange newAffectedClassName: 'ChangesTest' categoryName: 'DAO-TP-Changes'.
	unaInterfaceDeEventosDeEntrada handle: unCambio.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 2.
	self assert: unSistemaDeCambios todosLosCambios size = 1! !

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test011UnCambioDebeSaberEnQueMomentoFueRealizadoYPorQuien
	
	| unSistemaDeCambios unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := ClassCreatedChange newAffectedClassName: 'ChangesTest' categoryName: 'DAO-TP-Changes'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.

	self assert: ( unSistemaDeCambios todosLosCambios allSatisfy: [ :unRegistroDeCambio | (((unRegistroDeCambio autor = self autorTest fullName ) 
																								and: unRegistroDeCambio fechaYHora = self relojTest now) 
																								and: unRegistroDeCambio cambio affectedClassName = 'ChangesTest')
																								and:  unRegistroDeCambio cambio categoryName = 'DAO-TP-Changes'] ).
	! !

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test012ElSistemaRegistraLosCambiosDeTipoClassRemoved
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := ClassRemovedChange newAffectedClassName: 'ChangesTest' categoryName: 'DAO-TP-Changes'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	self assert: ( unSistemaDeCambios todosLosCambios allSatisfy: [ :unRegistroDeCambio | (((unRegistroDeCambio autor = self autorTest fullName ) 
																								and: unRegistroDeCambio fechaYHora = self relojTest now) 
																								and: unRegistroDeCambio cambio affectedClassName = 'ChangesTest')
																								and:  unRegistroDeCambio cambio categoryName = 'DAO-TP-Changes'] ).! !

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test013ElSistemaRegistraLosCambiosDeTipoClassRecategorized
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := ClassRecategorizedChange classAffected: 'ChangesTest' from: 'DAO-TP-Changes-old' to: 'DAO-TP-Changes'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTest').
		self assert: (unRegistroDeCambio cambio oldCategoryName = 'DAO-TP-Changes-old').
		self assert: (unRegistroDeCambio cambio newCategoryName = 'DAO-TP-Changes').
		]! !

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test014ElSistemaRegistraLosCambiosDeTipoClassMethodCreated
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := ClassMethodCreatedChange onClass: 'ChangesTestClass' selector: 'nombreDelMetodo' protocol: 'as yet unclassified' sourceCode: '^self'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTestClass').
		self assert: (unRegistroDeCambio cambio selector = 'nombreDelMetodo').
		self assert: (unRegistroDeCambio cambio protocol = 'as yet unclassified').
		self assert: (unRegistroDeCambio cambio sourceCode = '^self').	
		]! !

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test015ElSistemaRegistraLosCambiosDeTipoClassMethodRemoved
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := ClassMethodRemovedChange onClass: 'ChangesTestClass' selector: 'nombreDelMetodo' protocol: 'as yet unclassified' sourceCode: '^self'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTestClass').
		self assert: (unRegistroDeCambio cambio selector = 'nombreDelMetodo').
		self assert: (unRegistroDeCambio cambio protocol = 'as yet unclassified').
		self assert: (unRegistroDeCambio cambio sourceCode = '^self').	
		]! !

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test016ElSistemaRegistraLosCambiosDeTipoInstanceMethodCreated
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := InstanceMethodCreatedChange onClass: 'ChangesTest' selector: 'nombreDelMetodo' protocol: 'as yet unclassified' sourceCode: '^self'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTest').
		self assert: (unRegistroDeCambio cambio selector = 'nombreDelMetodo').
		self assert: (unRegistroDeCambio cambio protocol = 'as yet unclassified').
		self assert: (unRegistroDeCambio cambio sourceCode = '^self').	
		]! !

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test017ElSistemaRegistraLosCambiosDeTipoInstanceMethodRemoved
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := ClassMethodRemovedChange onClass: 'ChangesTestClass' selector: 'nombreDelMetodo' protocol: 'as yet unclassified' sourceCode: '^self'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTestClass').
		self assert: (unRegistroDeCambio cambio selector = 'nombreDelMetodo').
		self assert: (unRegistroDeCambio cambio protocol = 'as yet unclassified').
		self assert: (unRegistroDeCambio cambio sourceCode = '^self').	
		]! !

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test018ElSistemaRegistraLosCambiosDeTipoClassCategoryCreated_y_ClassCategoryRemoved
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada handle: (ClassCategoryCreatedChange newName: 'DAO-TP-Changes').
	unaInterfaceDeEventosDeEntrada handle: (ClassCategoryRemovedChange newName: 'DAO-TP-Changes').
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio categoryName = 'DAO-TP-Changes').
		]! !

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test900LaIntefazParaLosAnunciosDePharoPuedeHandlearYEnviarUnCambioDeTipoClassCreated_y_ClassRemoved

 | systemAnnouncerTest unSistemaDeCambios unaInterfaceDeEventosDeEntrada |
 

 systemAnnouncerTest := self unSystemAnnouncer.
 unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
 
 InterfazParaLosAnuncios newWith: systemAnnouncerTest and: unaInterfaceDeEventosDeEntrada.
 
 unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
 
 systemAnnouncerTest classAdded: ChangesTest inCategory: #'DAO-TP-Changes'.
 systemAnnouncerTest classRemoved: ChangesTest fromCategory: #'DAO-TP-Changes'.
 
 unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
  self assert: (unRegistroDeCambio autor = self autorTest fullName).
  self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
  self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTest').
  self assert: (unRegistroDeCambio cambio categoryName = 'DAO-TP-Changes'). 
  ].! !

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test901LaIntefazParaLosAnunciosDePharoPuedeHandlearYEnviarUnCambioDeTipoClassMethodCreated_y_ClassMethodRemoved
	| systemAnnouncerTest unSistemaDeCambios unaInterfaceDeEventosDeEntrada unMetodo |

 	systemAnnouncerTest := self unSystemAnnouncer.
	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
 
	InterfazParaLosAnuncios newWith: systemAnnouncerTest and: unaInterfaceDeEventosDeEntrada.
 
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	unMetodo :=  (self class class methodDict  at: #mensajeTest).

	systemAnnouncerTest methodAdded: unMetodo selector: unMetodo selector inProtocol: 'as yet unclassified' class: unMetodo methodClass requestor: nil.
	systemAnnouncerTest methodRemoved: unMetodo selector: unMetodo selector inProtocol: 'as yet unclassified' class: unMetodo methodClass origin: unMetodo origin.

	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTest class').
		self assert: (unRegistroDeCambio cambio selector = unMetodo selector).
		self assert: (unRegistroDeCambio cambio protocol = 'as yet unclassified').
		self assert: (unRegistroDeCambio cambio sourceCode = unMetodo decompile printString) .	
 		].! !

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test902LaIntefazParaLosAnunciosDePharoPuedeHandlearYEnviarUnCambioDeTipoInstanceMethodCreated_y_InstanceMethodRemoved

 | systemAnnouncerTest unSistemaDeCambios unaInterfaceDeEventosDeEntrada unMetodo |
 
	systemAnnouncerTest := self unSystemAnnouncer.
	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
 
	InterfazParaLosAnuncios newWith: systemAnnouncerTest and: unaInterfaceDeEventosDeEntrada.
 
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	unMetodo :=  (self class methodDict  at: #now).
	systemAnnouncerTest methodAdded: unMetodo selector: unMetodo selector inProtocol: 'as yet unclassified' class: unMetodo methodClass requestor: nil.
	systemAnnouncerTest methodRemoved: unMetodo selector: unMetodo selector inProtocol: 'as yet unclassified' class: unMetodo methodClass origin: unMetodo origin.

	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTest').
		self assert: (unRegistroDeCambio cambio selector = unMetodo selector).
		self assert: (unRegistroDeCambio cambio protocol = 'as yet unclassified').
		self assert: (unRegistroDeCambio cambio sourceCode = unMetodo decompile printString) .	
  ].! !

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test903LaIntefazParaLosAnunciosDePharoPuedeHandlearYEnviarUnCambioDeTipoSuperclassChanged
 | systemAnnouncerTest unSistemaDeCambios unaInterfaceDeEventosDeEntrada unaClase otraClase |
 

	systemAnnouncerTest := self unSystemAnnouncer.
	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
 
	InterfazParaLosAnuncios newWith: systemAnnouncerTest and: unaInterfaceDeEventosDeEntrada.
 
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.

	unaClase := (ChangesTest subclass:  #Blah category: 'DAO-TP-Changes') copy.
	otraClase := Object subclass:  #Blah category: 'DAO-TP-Changes'.

	systemAnnouncerTest  classDefinitionChangedFrom: unaClase to: otraClase.

	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = #Blah).
		self assert: (unRegistroDeCambio cambio oldSuperclassName = #ChangesTest).
		self assert: (unRegistroDeCambio cambio newSuperclassName = #Object).
  ].! !

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test904LaIntefazParaLosAnunciosDePharoPuedeHandlearYEnviarUnCambioDeTipoClassCategoryRenamed
 | systemAnnouncerTest unSistemaDeCambios unaInterfaceDeEventosDeEntrada |
 

	systemAnnouncerTest := self unSystemAnnouncer.
	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
 
	InterfazParaLosAnuncios newWith: systemAnnouncerTest and: unaInterfaceDeEventosDeEntrada.
 
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.

	systemAnnouncerTest  classCategoryRenamedFrom: 'asd1' to: 'asd2'.

	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio oldCategoryName = 'asd1').
		self assert: (unRegistroDeCambio cambio newCategoryName = 'asd2').
  ].! !

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test905LaIntefazParaLosAnunciosDePharoPuedeHandlearYEnviarUnCambioDeTipo_ClassMethodCategoryRenamed_y_InstanceMethodRecategorized
	| systemAnnouncerTest unSistemaDeCambios unaInterfaceDeEventosDeEntrada |
 
	systemAnnouncerTest := self unSystemAnnouncer.
	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	
	InterfazParaLosAnuncios newWith: systemAnnouncerTest and: unaInterfaceDeEventosDeEntrada.
 	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	systemAnnouncerTest  selector: #now recategorizedFrom: 'as yet unclassified' to: 'categoryTest' inClass: ChangesTest.
	systemAnnouncerTest  selector: #mensajeTest recategorizedFrom: 'as yet unclassified' to: 'categoryTest' inClass: ChangesTest class.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio |
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio oldCategoryName  = #'as yet unclassified').
		self assert: (unRegistroDeCambio cambio newCategoryName  = #'categoryTest').
		(unRegistroDeCambio cambio isKindOf: ClassMethodCategoryRenamedChange)
			ifTrue: [
				self assert: (unRegistroDeCambio cambio affectedClassName = #'ChangesTest class').
				self assert: (unRegistroDeCambio cambio affectedMethodName = #mensajeTest).
				]
			ifFalse:[
				(unRegistroDeCambio cambio isKindOf: InstanceMethodRecategorizedChange)ifFalse: [ self fail ].
				self assert: (unRegistroDeCambio cambio affectedClassName = #ChangesTest).
				self assert: (unRegistroDeCambio cambio affectedMethodName = #now).
				]
		].! !

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test906LaIntefazParaLosAnunciosDePharoPuedeHandlearYEnviarUnCambioDeTipo_ClassCategoryCreated_y_ClassCategoryRemoved

	| systemAnnouncerTest unSistemaDeCambios unaInterfaceDeEventosDeEntrada aClassCategoryName |

 	systemAnnouncerTest := self unSystemAnnouncer.
	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	
	InterfazParaLosAnuncios newWith: systemAnnouncerTest and: unaInterfaceDeEventosDeEntrada.
	
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	aClassCategoryName := 'DAO-TP-Changes'.
	
	systemAnnouncerTest  classCategoryAdded: aClassCategoryName .
	systemAnnouncerTest  classCategoryRemoved: aClassCategoryName .

	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio categoryName = aClassCategoryName).
		].! !

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test907LaIntefazParaLosAnunciosDePharoPuedeHandlearYEnviarUnCambioDeTipo_ClassRecategorized

	| systemAnnouncerTest unSistemaDeCambios unaInterfaceDeEventosDeEntrada aClassCategoryName aClassCategoryNameOld|

 	systemAnnouncerTest := self unSystemAnnouncer.
	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	
	InterfazParaLosAnuncios newWith: systemAnnouncerTest and: unaInterfaceDeEventosDeEntrada.
	
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	aClassCategoryNameOld := 'DAO-TP-Changes-old'.
	aClassCategoryName := 'DAO-TP-Changes'.
	
	systemAnnouncerTest class: ChangesTest class recategorizedFrom: aClassCategoryNameOld to: aClassCategoryName. 

	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName= ChangesTest class name).
		self assert: (unRegistroDeCambio cambio oldCategoryName = aClassCategoryNameOld ).
		self assert: (unRegistroDeCambio cambio newCategoryName = aClassCategoryName).
		].! !

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test950LaIntefazParaLosAnunciosDePharoPuedeHandlearYEnviarUnCambioDeTipoInstanceMethodChanged
	| systemAnnouncerTest unSistemaDeCambios unaInterfaceDeEventosDeEntrada unMetodo |

	systemAnnouncerTest := self unSystemAnnouncer.
	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	
	InterfazParaLosAnuncios newWith: systemAnnouncerTest and: unaInterfaceDeEventosDeEntrada.
 	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.

	unMetodo :=  (self class methodDict  at: #now).
	systemAnnouncerTest methodChangedFrom: unMetodo to: unMetodo selector: #now inClass: ChangesTest oldProtocol: 'as yet unclassified' newProtocol: 'categoryTest' requestor: nil.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio |
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio oldCategoryName  = #'as yet unclassified').
		self assert: (unRegistroDeCambio cambio newCategoryName  = #'categoryTest').
		self assert: (unRegistroDeCambio cambio oldSourceCode  = unMetodo decompile printString ).
		self assert: (unRegistroDeCambio cambio newSourceCode  = unMetodo decompile printString).
		]
! !

!InterfazDeEventosDeEntradaTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastianGarbi 10/13/2013 21:36'!
test951LaIntefazParaLosAnunciosDePharoPuedeHandlearYEnviarUnCambioDeTipoClassMethodChanged
	| systemAnnouncerTest unSistemaDeCambios unaInterfaceDeEventosDeEntrada unMetodo |

	systemAnnouncerTest := self unSystemAnnouncer.
	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	
	InterfazParaLosAnuncios newWith: systemAnnouncerTest and: unaInterfaceDeEventosDeEntrada.
 	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.

	unMetodo :=  (self class class methodDict  at: #mensajeTest).
	systemAnnouncerTest methodChangedFrom: unMetodo to: unMetodo selector: #mensajeTest inClass: ChangesTest class oldProtocol: 'as yet unclassified' newProtocol: 'categoryTest' requestor: nil.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio |
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio oldCategoryName  = #'as yet unclassified').
		self assert: (unRegistroDeCambio cambio newCategoryName  = #'categoryTest').
		self assert: (unRegistroDeCambio cambio oldSourceCode  = unMetodo decompile printString ).
		self assert: (unRegistroDeCambio cambio newSourceCode  = unMetodo decompile printString).
		]
! !

ChangesTest subclass: #SistemaDeCambiosTest
	instanceVariableNames: 'diccionarioDeAcciones nombreDelAutor fechaYHoraTest registroDePruebaC1 registroDePruebaC2 registroDePruebaC3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!SistemaDeCambiosTest methodsFor: '02SistemaDeCambios' stamp: 'SebastianGarbi 10/13/2013 21:37'!
test200UnSistemaDeCambiosSeInicializaConUnaUnidadDeTrabajoActivaVacia
	
	| unSistemaDeCambios |
	
	unSistemaDeCambios := SistemaDeCambios new.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
	self assert: unSistemaDeCambios unidadActiva todosLosCambios size = 0.! !

!SistemaDeCambiosTest methodsFor: '02SistemaDeCambios' stamp: 'SebastianGarbi 10/13/2013 21:37'!
test201ElSistemaRegistraElCambioEnLaUnidadActiva
	
	| unSistemaDeCambios unaUnidadDeTrabajo |

	unSistemaDeCambios := SistemaDeCambios new.
	
	unSistemaDeCambios registrarCambio: self registroClassCreatedC1.
	unaUnidadDeTrabajo := unSistemaDeCambios unidadActiva. 

	self assert: unaUnidadDeTrabajo todosLosCambios size = 1.
	self assert: (unaUnidadDeTrabajo todosLosCambios allSatisfy: [ :unCambio | unCambio = self registroClassCreatedC1 ]).
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.! !

!SistemaDeCambiosTest methodsFor: '02SistemaDeCambios' stamp: 'SebastianGarbi 10/13/2013 21:37'!
test202ElSistemaAlCerrarLaUnidadActivaSoloTieneUnidadesDeTrabajoCerradas
	
	| unSistemaDeCambios |
	
	unSistemaDeCambios := SistemaDeCambios new.
	
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
	self assert: ( unSistemaDeCambios unidadesDeTrabajo allSatisfy: [ :unaUnidadDeTrabajo | unaUnidadDeTrabajo estaCerrada ] ).! !

!SistemaDeCambiosTest methodsFor: '02SistemaDeCambios' stamp: 'SebastianGarbi 10/13/2013 21:37'!
test203ElSistemaAlCerrarLaUnidadActivaNoCreaUnaUnidadNueva
	
	| unSistemaDeCambios |
	
	unSistemaDeCambios := SistemaDeCambios new.
	
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	
	self assert: unSistemaDeCambios unidadActiva estaCerrada .
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.! !

!SistemaDeCambiosTest methodsFor: '02SistemaDeCambios' stamp: 'SebastianGarbi 10/13/2013 21:37'!
test210ElSistemaPuedeCrearCambiosEnDistintasUnidades
	| unSistemaDeCambios unaInterfaceDeEventosDeEntrada unCambio |
	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	unCambio := self registroClassCreatedC1.
	unaInterfaceDeEventosDeEntrada handle: unCambio.
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	unaInterfaceDeEventosDeEntrada handle: unCambio.
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	unaInterfaceDeEventosDeEntrada handle: unCambio.
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 4.
	self assert: unSistemaDeCambios todosLosCambios size = 3.
	unSistemaDeCambios todosLosCambios
		allSatisfy: [ :unRegistroDeCambio |
			unRegistroDeCambio autor = self autorTest fullName and: unRegistroDeCambio fechaYHora = self relojTest now ]! !

!SistemaDeCambiosTest methodsFor: '02SistemaDeCambios' stamp: 'SebastianGarbi 10/13/2013 21:57'!
test211ElSistemaPuedeObtenerLaHistoriaDeUnMetodoDeClase
 | unSistemaDeCambios unaInterfaceDeEventosDeEntrada aClassName aCategory aMethodName aProtocol aSourceCode |

unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.

aClassName := 'ChangesTest'.
aCategory := 'DAO-TP-Changes'.
aMethodName := 'now'.
aProtocol := 'as yet unclassified'.
aSourceCode := '^ fechaYHoraTest'.

unaInterfaceDeEventosDeEntrada classCreated: aClassName inCategory: aCategory.
unaInterfaceDeEventosDeEntrada instanceMethod: aMethodName createdOn: aClassName inCategory: aProtocol withCode: aSourceCode.
unaInterfaceDeEventosDeEntrada classMethod: aMethodName createdOn: aClassName inCategory: aProtocol withCode: aSourceCode.
unaInterfaceDeEventosDeEntrada classMethod: aMethodName createdOn: aClassName inCategory: aProtocol withCode: aSourceCode.

unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
unaInterfaceDeEventosDeEntrada classMethod: aMethodName createdOn: aClassName inCategory: aProtocol withCode: aSourceCode.

unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
unaInterfaceDeEventosDeEntrada classMethod: aMethodName createdOn: aClassName inCategory: aProtocol withCode: aSourceCode.

self assert: unSistemaDeCambios unidadesDeTrabajo size = 3.
self assert: unSistemaDeCambios todosLosCambios size = 6.
self assert: (unSistemaDeCambios historiaDelMetodoDeClase: aMethodName deLaClase: aClassName) size = 3. 
 ! !

!SistemaDeCambiosTest methodsFor: '02SistemaDeCambios' stamp: 'SebastianGarbi 10/13/2013 21:37'!
test212ElSistemaPuedeObtenerLaHistoriaDeUnMetodoDeInstancia
 | unSistemaDeCambios unaInterfaceDeEventosDeEntrada unCambio otroCambio otroCambio2 otroCambio3 |

 unaInterfaceDeEventosDeEntrada:= self unaInterfaceDeEventosDeEntradaInicializada.
 unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
   

 unCambio := ClassCreatedChange newAffectedClassName: 'ChangesTest' categoryName: 'DAO-TP-Changes'.

 unaInterfaceDeEventosDeEntrada handle: unCambio.

 otroCambio :=  (InstanceMethodCreatedChange  	onClass: 'ChangesTest' 
													selector: 'now' 
													protocol: 'as yet unclassified' 
													sourceCode: 'now
	^ fechaYHoraTest' ).
otroCambio2 := (ClassMethodCreatedChange   	onClass: 'ChangesTest' 
													selector: 'now' 
													protocol: 'as yet unclassified' 
													sourceCode: 'now
	^ fechaYHoraTest' ).
 otroCambio3 :=  (InstanceMethodCreatedChange  	onClass: 'ChangesTest' 
													selector: 'notNow' 
													protocol: 'as yet unclassified' 
													sourceCode: 'now
	^ fechaYHoraTest' ).

unaInterfaceDeEventosDeEntrada handle: otroCambio.
unaInterfaceDeEventosDeEntrada handle: otroCambio2.
unaInterfaceDeEventosDeEntrada handle: otroCambio3.
																						
 unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
 unaInterfaceDeEventosDeEntrada handle: otroCambio.

 unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
 unaInterfaceDeEventosDeEntrada handle: otroCambio.
 
 self assert: unSistemaDeCambios unidadesDeTrabajo size = 3.
 self assert: unSistemaDeCambios todosLosCambios size = 6.
 self assert: ( unSistemaDeCambios historiaDelMetodoDeInstancia: 'now' deLaClase: 'ChangesTest' ) size = 3.
 self assert: ( (unSistemaDeCambios historiaDelMetodoDeInstancia: 'now' deLaClase: 'ChangesTest') allSatisfy: [ :unRegistroDeCambio | 
										((unRegistroDeCambio autor = self autorTest fullName ) 
  										and: unRegistroDeCambio fechaYHora = self relojTest now) 
										and: unRegistroDeCambio cambio = otroCambio
										] ).! !

!SistemaDeCambiosTest methodsFor: '02SistemaDeCambios' stamp: 'SebastianGarbi 10/13/2013 21:37'!
test220ElSistemaAlCerrarLaUnidadActivaLeAsignaUnID
	
	| unSistemaDeCambios id01 id02 |
	
	unSistemaDeCambios := SistemaDeCambios new.
	
	unSistemaDeCambios registrarCambio: self registroClassCreatedC1.
	id01 := unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	
	unSistemaDeCambios registrarCambio: self registroClassCreatedC2.
	id02 := unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	
	unSistemaDeCambios registrarCambio: self registroClassCreatedC3.
	
	self assert: unSistemaDeCambios todosLosCambios size = 3.
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 3.
	self deny: id01 = id02.! !

ChangesTest subclass: #UnidadDeTrabajoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!UnidadDeTrabajoTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastianGarbi 10/13/2013 21:34'!
test001LaUnidadDeTrabajoInicialNoSabeResponderElMensajePadre
	| unaUnidadDeTrabajoInicial |
	unaUnidadDeTrabajoInicial := UnidadDeTrabajoInicial new.
	self should: [ unaUnidadDeTrabajoInicial padre ]
			raise:  MessageNotUnderstood 
			withExceptionDo: [ :aMessageNotUnderstood  | aMessageNotUnderstood messageText = '#padre' ]
! !

!UnidadDeTrabajoTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastianGarbi 10/13/2013 21:34'!
test002UnaUnidadDeTrabajoSeCreaSinCambiosYAbierta
	| unaUnidadDeTrabajo |
	unaUnidadDeTrabajo := UnidadDeTrabajoReal newWith: self algunaUnidadDeTrabajo.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty.
	self deny: unaUnidadDeTrabajo estaCerrada.
	
	unaUnidadDeTrabajo := UnidadDeTrabajoInicial new.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty.
	self deny: unaUnidadDeTrabajo estaCerrada.! !

!UnidadDeTrabajoTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastianGarbi 10/13/2013 21:34'!
test003UnaUnidadDeTrabajoQueRegistraUnCambioNoEstaVacia
	
	| unaUnidadDeTrabajo |
	unaUnidadDeTrabajo := UnidadDeTrabajoReal newWith: self algunaUnidadDeTrabajo.
	unaUnidadDeTrabajo registrarCambio: self registroClassCreatedC1.
	self deny: unaUnidadDeTrabajo todosLosCambios isEmpty.! !

!UnidadDeTrabajoTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastianGarbi 10/13/2013 21:34'!
test004RegistrarUnCambioEnUnidadCerradaLanzaUnaExcepcion
	
	| unaUnidadDeTrabajo |
	
	unaUnidadDeTrabajo := UnidadDeTrabajoReal newWith: self algunaUnidadDeTrabajo .
	unaUnidadDeTrabajo cerrar.

	self should: [ unaUnidadDeTrabajo registrarCambio: self registroClassCreatedC1 ] raise: Error withExceptionDo:  [ :anError | anError messageText  = UnidadDeTrabajoReal noSePuedeRegistrarCambios.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty ].

	! !

!UnidadDeTrabajoTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastianGarbi 10/13/2013 21:34'!
test007UnaunidadDeTrabajoRealConoceASuPadre
	| unaUnidadDeTrabajoPadre unaUnidadDeTrabajo |
	unaUnidadDeTrabajoPadre := self algunaUnidadDeTrabajo.
	unaUnidadDeTrabajo  := UnidadDeTrabajoReal newWith: unaUnidadDeTrabajoPadre.
	self assert: (unaUnidadDeTrabajo padre = unaUnidadDeTrabajoPadre).! !

Object subclass: #Blah
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

Object subclass: #Change
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!Change class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:03'!
evento
	self subclassResponsibility.! !

!Change methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:58'!
esCambioDeMensajeDeClase: aSelector deLaClase: aClass 
	self subclassResponsibility ! !

!Change methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:58'!
esCambioDeMensajeDeInstancia: anObject deLaClase: anObject1
	self subclassResponsibility ! !

!Change methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:02'!
evento
	^self class evento.! !

Change subclass: #ClassCategoryCreatedChange
	instanceVariableNames: 'categoryName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassCategoryCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:11'!
categoryName: aCategory
	^self new categoryName: aCategory.! !

!ClassCategoryCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:08'!
evento
	^#'ClassCategoryCreated'! !

!ClassCategoryCreatedChange methodsFor: 'accessing' stamp: 'SebastianGarbi 10/13/2013 19:11'!
categoryName
	^ categoryName! !

!ClassCategoryCreatedChange methodsFor: 'accessing' stamp: 'SebastianGarbi 10/13/2013 19:11'!
categoryName: anObject
	categoryName := anObject! !

Change subclass: #ClassCategoryRemovedChange
	instanceVariableNames: 'categoryName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassCategoryRemovedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:12'!
categoryName: aByteSymbol 
	^self new categoryName: aByteSymbol.! !

!ClassCategoryRemovedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:08'!
evento
	^#'ClassCategoryRemoved'! !

!ClassCategoryRemovedChange methodsFor: 'accessing' stamp: 'SebastianGarbi 10/13/2013 19:12'!
categoryName
	^ categoryName! !

!ClassCategoryRemovedChange methodsFor: 'accessing' stamp: 'SebastianGarbi 10/13/2013 19:12'!
categoryName: anObject
	categoryName := anObject! !

Change subclass: #ClassCategoryRenamedChange
	instanceVariableNames: 'oldCategoryName newCategoryName classCategoryRenamedFrom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassCategoryRenamedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:09'!
evento
	^#'ClassCategoryRenamed'! !

!ClassCategoryRenamedChange class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 01:13'!
from: oldName to: newName
	^self new oldCategoryName: oldName newCategoryName: newName.
	! !

!ClassCategoryRenamedChange methodsFor: 'as yet unclassified' stamp: 'Maxiii 9/30/2013 12:10'!
esCambioDeMensajeDeClase: aSelector deLaClase: aClass 
	^false.! !

!ClassCategoryRenamedChange methodsFor: 'as yet unclassified' stamp: 'Maxii 9/30/2013 11:00'!
esCambioDeMensajeDeInstancia: anObject deLaClase: anObject1
	^false.! !

!ClassCategoryRenamedChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 01:15'!
newCategoryName
	^ newCategoryName! !

!ClassCategoryRenamedChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 01:15'!
oldCategoryName
	^ oldCategoryName! !

!ClassCategoryRenamedChange methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 01:15'!
oldCategoryName: oldName newCategoryName: newName.
	oldCategoryName := oldName.
	newCategoryName := newName.! !

Change subclass: #ClassCreatedChange
	instanceVariableNames: 'classCreated classCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 18:01'!
class: aClassName category: aCategoryName 
	^self new classCreated: aClassName classCategory: aCategoryName.! !

!ClassCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:07'!
evento
	^#'ClassCreated'! !

!ClassCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 21:33'!
nuevo
	^self new.! !

!ClassCreatedChange methodsFor: 'accessing' stamp: 'SebastianGarbi 10/13/2013 18:09'!
classCategory
	^ classCategory! !

!ClassCreatedChange methodsFor: 'accessing' stamp: 'SebastianGarbi 10/13/2013 18:09'!
classCreated
	^ classCreated! !

!ClassCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 18:10'!
classCreated: aClassName  classCategory: aCategoryName 
	classCreated := aClassName.
	classCategory := aCategoryName.! !

!ClassCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 22:15'!
esCambioDeMensajeDeClase: aSelector deLaClase: aClass 
	^false.! !

Change subclass: #ClassInstanceVariableCreatedChange
	instanceVariableNames: 'classAffected variableName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassInstanceVariableCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:33'!
classAffected: aClassName variableName: aVariableName
	^self new classAffected: aClassName variableName: aVariableName.! !

!ClassInstanceVariableCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:11'!
evento
	^#'ClassInstanceVariableCreated'! !

!ClassInstanceVariableCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:34'!
classAffected
	^ classAffected! !

!ClassInstanceVariableCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:53'!
classAffected: aClassName variableName: aVariableName
	classAffected := aClassName.
	variableName := aVariableName.
	! !

!ClassInstanceVariableCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:34'!
variableName
	^ variableName! !

Change subclass: #ClassInstanceVariableRemovedChange
	instanceVariableNames: 'classAffected variableName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

ClassInstanceVariableRemovedChange class
	instanceVariableNames: 'classAffected variableName'!

ClassInstanceVariableRemovedChange class
	instanceVariableNames: 'classAffected variableName'!

!ClassInstanceVariableRemovedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:59'!
classAffected: aClassName variableName: aVariableName
	^self new classAffected: aClassName variableName: aVariableName.
	! !

!ClassInstanceVariableRemovedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:11'!
evento
	^#'ClassInstanceVariableRemoved'! !

!ClassInstanceVariableRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:58'!
classAffected
	^classAffected.! !

!ClassInstanceVariableRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:58'!
classAffected: aClassName variableName: aVariableName
	classAffected := aClassName.
	variableName := aVariableName.
	! !

!ClassInstanceVariableRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:58'!
variableName
	^ variableName! !

Change subclass: #ClassMethodCategoryCreatedChange
	instanceVariableNames: 'categoryName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassMethodCategoryCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:22'!
categoryName: aCategory
	^self new categoryName: aCategory.! !

!ClassMethodCategoryCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:23'!
evento
	^#'ClassMethodCategoryCreated'! !

!ClassMethodCategoryCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:22'!
categoryName
	^ categoryName! !

!ClassMethodCategoryCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:22'!
categoryName: anObject
	categoryName := anObject! !

Change subclass: #ClassMethodCategoryRenamedChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassMethodCategoryRenamedChange methodsFor: 'as yet unclassified' stamp: 'Maxiii 9/30/2013 12:19'!
esCambioDeMensajeDeClase: aSelector deLaClase: aClass 
	^affectedClassName = aClass and: aSelector = selector.! !

!ClassMethodCategoryRenamedChange methodsFor: 'as yet unclassified' stamp: 'Maxii 9/30/2013 11:00'!
esCambioDeMensajeDeInstancia: anObject deLaClase: anObject1
	^false.! !

Change subclass: #ClassMethodChangedChange
	instanceVariableNames: 'affectedClassName selector oldMethod newMethod oldCategory newCategory classAffected methodName oldSourceCode newSourceCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassMethodChangedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:05'!
classAffected: aClassName methodName: aMethodName oldSourceCode: anOldSource newSourceCode: aNewSource
	^self new classAffected: aClassName methodName: aMethodName oldSourceCode: anOldSource newSourceCode: aNewSource! !

!ClassMethodChangedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:12'!
evento 
	^#'ClassMethodChanged'! !

!ClassMethodChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:06'!
classAffected
	^classAffected! !

!ClassMethodChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:06'!
classAffected: aClassName methodName: aMethodName oldSourceCode: anOldSource newSourceCode: aNewSource
	classAffected := aClassName.
	methodName := aMethodName.
	oldSourceCode := anOldSource.
	newSourceCode := aNewSource. ! !

!ClassMethodChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/30/2013 18:45'!
esCambioDeMensajeDeClase: aSelector deLaClase: aClass 
	^affectedClassName = aClass and: aSelector = selector.! !

!ClassMethodChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/30/2013 18:46'!
esCambioDeMensajeDeInstancia: anObject deLaClase: anObject1
	^false.! !

!ClassMethodChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:06'!
methodName
	^ methodName! !

!ClassMethodChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:10'!
newSourceCode
	^newSourceCode.! !

!ClassMethodChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:10'!
oldSourceCode
	^oldSourceCode.! !

Change subclass: #ClassMethodCreatedChange
	instanceVariableNames: 'classAffected methodName methodCategory sourceCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassMethodCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:35'!
classAffected: aClassName methodName: aMethodName methodCategory: aProtocol sourceCode: aSourceCode
	^self new classAffected: aClassName methodName: aMethodName methodCategory: aProtocol sourceCode: aSourceCode.! !

!ClassMethodCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:38'!
evento
	^#'ClassMethodCreated'! !

!ClassMethodCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:36'!
classAffected
	^ classAffected! !

!ClassMethodCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:36'!
classAffected: aClassName methodName: aMethodName methodCategory: aProtocol sourceCode: aSourceCode
	classAffected := aClassName.
	methodName := aMethodName.
	methodCategory := aProtocol.
	sourceCode := aSourceCode. ! !

!ClassMethodCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 22:24'!
esCambioDeMensajeDeClase: aMethodName deLaClase: aClassName
	^true! !

!ClassMethodCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:36'!
methodCategory
	^ methodCategory! !

!ClassMethodCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:36'!
methodName
	^ methodName! !

!ClassMethodCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:37'!
sourceCode
	^ sourceCode! !

Change subclass: #ClassMethodRecategorizedChange
	instanceVariableNames: 'classAffected methodName oldMethodCategory newMethodCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassMethodRecategorizedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:53'!
classAffected: aClassName methodName: aMethodName oldMethodCategory: aProtocol newMethodCategory: aNewProtocol
	^self new classAffected: aClassName methodName: aMethodName oldMethodCategory: aProtocol newMethodCategory: aNewProtocol.! !

!ClassMethodRecategorizedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:56'!
evento
	^#'ClassMethodRecategorized'! !

!ClassMethodRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:55'!
classAffected
	^ classAffected! !

!ClassMethodRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:55'!
classAffected: aClassName methodName: aMethodName oldMethodCategory: aProtocol newMethodCategory: aNewProtocol
	classAffected := aClassName.
	methodName := aMethodName.
	oldMethodCategory := aProtocol.
	newMethodCategory := aNewProtocol. ! !

!ClassMethodRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:55'!
methodName
	^ methodName! !

!ClassMethodRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:55'!
newMethodCategory
	^ newMethodCategory! !

!ClassMethodRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:55'!
oldMethodCategory
	^ oldMethodCategory! !

Change subclass: #ClassMethodRemovedChange
	instanceVariableNames: 'classAffected methodName methodCategory sourceCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassMethodRemovedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:45'!
classAffected: aClassName methodName: aMethodName methodCategory: aProtocol sourceCode: aSourceCode
	^self new classAffected: aClassName methodName: aMethodName methodCategory: aProtocol sourceCode: aSourceCode.! !

!ClassMethodRemovedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:45'!
evento
	^#'ClassMethodRemoved'! !

!ClassMethodRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:44'!
classAffected
	^ classAffected! !

!ClassMethodRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:44'!
classAffected: aClassName methodName: aMethodName methodCategory: aProtocol sourceCode: aSourceCode
	classAffected := aClassName.
	methodName := aMethodName.
	methodCategory := aProtocol.
	sourceCode := aSourceCode. ! !

!ClassMethodRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:44'!
methodCategory
	^ methodCategory! !

!ClassMethodRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:44'!
methodName
	^ methodName! !

!ClassMethodRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:44'!
sourceCode
	^ sourceCode! !

Change subclass: #ClassRecategorizedChange
	instanceVariableNames: 'classRecategorized oldCategory newCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassRecategorizedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:41'!
classRecategorized: aClassName oldCategory: oldCategoryName newCategory: newCategoryName
	^self new classRecategorized: aClassName oldCategory: oldCategoryName newCategory: newCategoryName.! !

!ClassRecategorizedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:09'!
evento
	^#'ClassRecategorized'! !

!ClassRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 18:29'!
classRecategorized
	^ classRecategorized! !

!ClassRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:45'!
classRecategorized: aClassName oldCategory: oldCategoryName newCategory: newCategoryName
	classRecategorized := aClassName.
	oldCategory := oldCategoryName.
	newCategory := newCategoryName.! !

!ClassRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'Maxiii 9/30/2013 12:10'!
esCambioDeMensajeDeClase: aSelector deLaClase: aClass 
	^false.! !

!ClassRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'Maxii 9/30/2013 11:00'!
esCambioDeMensajeDeInstancia: anObject deLaClase: anObject1
	^false.! !

!ClassRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 18:29'!
newCategory
	^ newCategory! !

!ClassRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 18:29'!
oldCategory
	^ oldCategory! !

Change subclass: #ClassRemovedChange
	instanceVariableNames: 'classRemoved classCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassRemovedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 18:18'!
class: aClassName category: aCategoryName
	^self new classRemoved: aClassName classCategory: aCategoryName.! !

!ClassRemovedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:08'!
evento
	^#'ClassRemoved'! !

!ClassRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 18:19'!
classCategory
	^ classCategory! !

!ClassRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 18:19'!
classRemoved
	^ classRemoved! !

!ClassRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:40'!
classRemoved: aClassName  classCategory: aCategoryName 
	classRemoved := aClassName.
	classCategory := aCategoryName.! !

Change subclass: #ClassVariableCreatedChange
	instanceVariableNames: 'classAffected variableName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassVariableCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:16'!
classAffected: aClassName variableName: aVariableName
	^self new classAffected: aClassName variableName: aVariableName.! !

!ClassVariableCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:15'!
evento
	^#'ClassVariableCreated'! !

!ClassVariableCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:15'!
classAffected
	^ classAffected! !

!ClassVariableCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:15'!
classAffected: aClassName variableName: aVariableName
	classAffected := aClassName.
	variableName := aVariableName.
	! !

!ClassVariableCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:15'!
variableName
	^ variableName! !

Change subclass: #ClassVariableRemovedChange
	instanceVariableNames: 'classAffected variableName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassVariableRemovedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:19'!
classAffected: aClassName variableName: aVariableName
	^self new classAffected: aClassName variableName: aVariableName.! !

!ClassVariableRemovedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:19'!
evento
	^#'ClassVariableRemoved'! !

!ClassVariableRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:19'!
classAffected
	^ classAffected! !

!ClassVariableRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:18'!
classAffected: aClassName variableName: aVariableName
	classAffected := aClassName.
	variableName := aVariableName.
	! !

!ClassVariableRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:19'!
variableName
	^ variableName! !

Change subclass: #InstanceMethodCategoryCreatedChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

Change subclass: #InstanceMethodChangedChange
	instanceVariableNames: 'affectedClassName selector oldMethod newMethod oldCategory newCategory classAffected methodName oldSourceCode newSourceCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InstanceMethodChangedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:17'!
classAffected: aClassName methodName: aMethodName oldSourceCode: anOldSource newSourceCode: aNewSource
	^self new classAffected: aClassName methodName: aMethodName oldSourceCode: anOldSource newSourceCode: aNewSource! !

!InstanceMethodChangedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:17'!
evento 
	^#'InstanceMethodChanged'! !

!InstanceMethodChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:16'!
classAffected
	^classAffected! !

!InstanceMethodChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:17'!
classAffected: aClassName methodName: aMethodName oldSourceCode: anOldSource newSourceCode: aNewSource
	classAffected := aClassName.
	methodName := aMethodName.
	oldSourceCode := anOldSource.
	newSourceCode := aNewSource. ! !

!InstanceMethodChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/30/2013 18:47'!
esCambioDeMensajeDeClase: aSelector deLaClase: aClass 
	^false.! !

!InstanceMethodChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/30/2013 18:47'!
esCambioDeMensajeDeInstancia: aSelector deLaClase: aClass
	^affectedClassName = aClass and: aSelector = selector.! !

!InstanceMethodChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:17'!
methodName
	^ methodName! !

!InstanceMethodChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:17'!
newSourceCode
	^newSourceCode.! !

!InstanceMethodChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:17'!
oldSourceCode
	^oldSourceCode.! !

Change subclass: #InstanceMethodCreatedChange
	instanceVariableNames: 'classAffected methodName methodCategory sourceCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InstanceMethodCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:18'!
classAffected: aClassName methodName: aMethodName methodCategory: aProtocol sourceCode: aSourceCode
	^self new classAffected: aClassName methodName: aMethodName methodCategory: aProtocol sourceCode: aSourceCode.! !

!InstanceMethodCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:18'!
evento
	^#'InstanceMethodCreated'! !

!InstanceMethodCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:18'!
classAffected
	^ classAffected! !

!InstanceMethodCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:18'!
classAffected: aClassName methodName: aMethodName methodCategory: aProtocol sourceCode: aSourceCode
	classAffected := aClassName.
	methodName := aMethodName.
	methodCategory := aProtocol.
	sourceCode := aSourceCode. ! !

!InstanceMethodCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 22:27'!
esCambioDeMensajeDeInstancia: aMethodName deLaClase: aClassName
	^true! !

!InstanceMethodCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:19'!
methodCategory
	^ methodCategory! !

!InstanceMethodCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:18'!
methodName
	^ methodName! !

!InstanceMethodCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:19'!
sourceCode
	^ sourceCode! !

Change subclass: #InstanceMethodRecategorizedChange
	instanceVariableNames: 'classAffected methodName oldMethodCategory newMethodCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InstanceMethodRecategorizedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:19'!
classAffected: aClassName methodName: aMethodName oldMethodCategory: aProtocol newMethodCategory: aNewProtocol
	^self new classAffected: aClassName methodName: aMethodName oldMethodCategory: aProtocol newMethodCategory: aNewProtocol.! !

!InstanceMethodRecategorizedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:20'!
evento
	^#'InstanceMethodRecategorized'! !

!InstanceMethodRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:19'!
classAffected
	^ classAffected! !

!InstanceMethodRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:19'!
classAffected: aClassName methodName: aMethodName oldMethodCategory: aProtocol newMethodCategory: aNewProtocol
	classAffected := aClassName.
	methodName := aMethodName.
	oldMethodCategory := aProtocol.
	newMethodCategory := aNewProtocol. ! !

!InstanceMethodRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'Maxiii 9/30/2013 12:18'!
esCambioDeMensajeDeClase: aSelector deLaClase: aClass 
	^false.! !

!InstanceMethodRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'Maxiii 9/30/2013 12:19'!
esCambioDeMensajeDeInstancia: aSelector deLaClase: aClass
	^affectedClassName = aClass and: aSelector = selector.
	! !

!InstanceMethodRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:19'!
methodName
	^ methodName! !

!InstanceMethodRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:19'!
newMethodCategory
	^ newMethodCategory! !

!InstanceMethodRecategorizedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:19'!
oldMethodCategory
	^ oldMethodCategory! !

Change subclass: #InstanceMethodRemovedChange
	instanceVariableNames: 'methodName methodCategory sourceCode classAffected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InstanceMethodRemovedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:24'!
classAffected: aClassName methodName: aMethodName methodCategory: aProtocol sourceCode: aSourceCode
	^self new classAffected: aClassName methodName: aMethodName methodCategory: aProtocol sourceCode: aSourceCode.! !

!InstanceMethodRemovedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:25'!
evento
	^#'InstanceMethodRemoved'! !

!InstanceMethodRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:26'!
classAffected
	^ classAffected! !

!InstanceMethodRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:26'!
classAffected: aClassName methodName: aMethodName methodCategory: aProtocol sourceCode: aSourceCode
	classAffected := aClassName.
	methodName := aMethodName.
	methodCategory := aProtocol.
	sourceCode := aSourceCode. ! !

!InstanceMethodRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:26'!
methodCategory
	^ methodCategory! !

!InstanceMethodRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:26'!
methodName
	^ methodName! !

!InstanceMethodRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 21:26'!
sourceCode
	^ sourceCode! !

Change subclass: #InstanceVariableCreatedChange
	instanceVariableNames: 'classAffected variableName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InstanceVariableCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:21'!
classAffected: aClassName variableName: aVariableName
	^self new classAffected: aClassName variableName: aVariableName.
	! !

!InstanceVariableCreatedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:10'!
evento
	^#'InstanceVariableCreated'! !

!InstanceVariableCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:21'!
classAffected
	^ classAffected! !

!InstanceVariableCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:48'!
classAffected: aClassName variableName: aVariableName
	classAffected := aClassName.
	variableName := aVariableName.
	! !

!InstanceVariableCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/30/2013 18:48'!
esCambioDeMensajeDeClase: aSelector deLaClase: aClass 
	^false.! !

!InstanceVariableCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/30/2013 18:49'!
esCambioDeMensajeDeInstancia: aSelector deLaClase: aClass
	^false.! !

!InstanceVariableCreatedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:26'!
variableName
	^variableName.! !

Change subclass: #InstanceVariableRemovedChange
	instanceVariableNames: 'classAffected variableName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InstanceVariableRemovedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:25'!
classAffected: aClassName variableName: aVariableName
	^self new  classAffected: aClassName variableName: aVariableName.! !

!InstanceVariableRemovedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:10'!
evento
	^#'InstanceVariableRemoved'! !

!InstanceVariableRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:25'!
classAffected
	^ classAffected! !

!InstanceVariableRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:48'!
classAffected: aClassName variableName: aVariableName
	classAffected := aClassName.
	variableName := aVariableName.
	! !

!InstanceVariableRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/30/2013 18:49'!
esCambioDeMensajeDeClase: aSelector deLaClase: aClass 
	^false.! !

!InstanceVariableRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/30/2013 18:49'!
esCambioDeMensajeDeInstancia: aSelector deLaClase: aClass
	^false.! !

!InstanceVariableRemovedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:26'!
variableName
	^variableName.! !

Change subclass: #SuperclassChangedChange
	instanceVariableNames: 'classAffected oldSuperclass newSuperclass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!SuperclassChangedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 18:44'!
classAffected: aClassName oldSuperclass: aSuperClassName newSuperclass: aSuperClassName2
	^self new classAffected: aClassName oldSuperclass: aSuperClassName newSuperclass: aSuperClassName2.! !

!SuperclassChangedChange class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 20:09'!
evento
	^#'SuperClassChanged'! !

!SuperclassChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 18:45'!
classAffected
	^ classAffected! !

!SuperclassChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 19:47'!
classAffected: aClassName oldSuperclass: oldSuperclassName newSuperclass: newSuperclassName
	classAffected := aClassName.
	oldSuperclass := oldSuperclassName.
	newSuperclass := newSuperclassName.
	! !

!SuperclassChangedChange methodsFor: 'as yet unclassified' stamp: 'Maxiii 9/30/2013 12:11'!
esCambioDeMensajeDeClase: aSelector deLaClase: aClass 
	^false.! !

!SuperclassChangedChange methodsFor: 'as yet unclassified' stamp: 'Maxii 9/30/2013 11:00'!
esCambioDeMensajeDeInstancia: anObject deLaClase: anObject1
	^false.! !

!SuperclassChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 18:46'!
newSuperclass
	^ newSuperclass! !

!SuperclassChangedChange methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 10/13/2013 18:46'!
oldSuperclass
	^ oldSuperclass! !

Object subclass: #InterfaceDeEntradaDelSistemaDeCambios
	instanceVariableNames: 'sistemaDeCambios autor reloj'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InterfaceDeEntradaDelSistemaDeCambios class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 16:22'!
newWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj 
	^self new initializeWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj.! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:52'!
agregarCambio: unCambio por: unNombreDeAutor enElMomento: unaFechaYHora 

	sistemaDeCambios registrarCambio: (RegistroDeCambio newWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora ).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 18:51'!
classCategoryCreated: aCategoryName
	self handle: (ClassCategoryCreatedChange categoryName: aCategoryName).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 18:58'!
classCategoryRemoved: aByteSymbol 
	self handle: (ClassCategoryRemovedChange categoryName: aByteSymbol)! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 19:04'!
classCategoryRenamedFrom: aByteSymbol to: aByteSymbol2 
	self handle: (ClassCategoryRenamedChange from: aByteSymbol to: aByteSymbol2 ).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 20:14'!
classCreated: aClassName inCategory: aCategoryName
	self handle: (ClassCreatedChange class: aClassName category: aCategoryName).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 19:32'!
classInstanceVariableCreatedOn: aClassName named: aVariableName 
	self handle: (ClassInstanceVariableCreatedChange classAffected: aClassName variableName: aVariableName).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 19:55'!
classInstanceVariableRemovedFrom: aClassName named: aVariableName
	self handle: (ClassInstanceVariableRemovedChange classAffected: aClassName variableName: aVariableName).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 20:33'!
classMethod: aMethodName createdOn: aClassName inCategory: aProtocol withCode: aSourceCode
	self handle: (ClassMethodCreatedChange classAffected: aClassName methodName: aMethodName methodCategory: aProtocol sourceCode: aSourceCode).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 20:52'!
classMethod: aMethodName onClass: aClassName recategorizedFrom: aProtocol to: aNewProtocol
	self handle: (ClassMethodRecategorizedChange classAffected: aClassName methodName: aMethodName oldMethodCategory: aProtocol newMethodCategory: aNewProtocol).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 20:46'!
classMethod: aMethodName removedFrom: aClassName inCategory: aProtocol withCode: aSourceCode
	self handle: (ClassMethodRemovedChange classAffected: aClassName methodName: aMethodName methodCategory: aProtocol sourceCode: aSourceCode).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 20:24'!
classMethodCategoryCreated: aCategoryName
	self handle: (ClassMethodCategoryCreatedChange categoryName: aCategoryName).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 21:04'!
classMethodChanged: aMethodName onClass: aClassName oldSourceCode: anOldSourceCode newSourceCode: aNewSourceCode
	self handle: (ClassMethodChangedChange classAffected: aClassName methodName: aMethodName oldSourceCode: anOldSourceCode newSourceCode: aNewSourceCode). ! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 20:14'!
classRecategorized: aClassName fromCategory: aCategory toCategory: anotherCategory
	self handle: (ClassRecategorizedChange classRecategorized: aClassName oldCategory: aCategory newCategory: anotherCategory).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 20:14'!
classRemoved: aClassName fromCategory: aCategoryName
	self handle: (ClassRemovedChange class: aClassName category: aCategoryName).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 20:17'!
classVariableCreatedOn: aClassName named: aVariableName 
	self handle: (ClassVariableCreatedChange classAffected: aClassName variableName: aVariableName).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 20:18'!
classVariableRemovedFrom: aClassName named: aVariableName 
	self handle: (ClassVariableRemovedChange classAffected: aClassName variableName: aVariableName).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:01'!
handle: unCambio 
	self agregarCambio: unCambio por: autor fullName enElMomento: reloj now.! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 16:22'!
initializeWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj
	sistemaDeCambios := unSistemaDeCambios.
	autor := unAutor.
	reloj := unReloj.! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 21:21'!
instanceMethod: aMethodName createdOn: aClassName inCategory: aProtocol withCode: aSourceCode
	self handle: (InstanceMethodCreatedChange classAffected: aClassName methodName: aMethodName methodCategory: aProtocol sourceCode: aSourceCode).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 21:21'!
instanceMethod: aMethodName onClass: aClassName recategorizedFrom: aProtocol to: aNewProtocol
	self handle: (InstanceMethodRecategorizedChange classAffected: aClassName methodName: aMethodName oldMethodCategory: aProtocol newMethodCategory: aNewProtocol).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 21:25'!
instanceMethod: aMethodName removedFrom: aClassName inCategory: aProtocol withCode: aSourceCode
	self handle: (InstanceMethodRemovedChange classAffected: aClassName methodName: aMethodName methodCategory: aProtocol sourceCode: aSourceCode).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 21:22'!
instanceMethodCategoryCreated: aCategoryName
	self handle: (InstanceMethodCategoryCreatedChange categoryName: aCategoryName).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 21:23'!
instanceMethodChanged: aMethodName onClass: aClassName oldSourceCode: anOldSourceCode newSourceCode: aNewSourceCode
	self handle: (InstanceMethodChangedChange classAffected: aClassName methodName: aMethodName oldSourceCode: anOldSourceCode newSourceCode: aNewSourceCode). ! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 19:20'!
instanceVariableCreatedOn: aByteSymbol named: aByteSymbol2 
	self handle: (InstanceVariableCreatedChange classAffected: aByteSymbol variableName: aByteSymbol2 ).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 19:24'!
instanceVariableRemovedFrom: aClassName named: aVariableName
	self handle: (InstanceVariableRemovedChange classAffected: aClassName variableName: aVariableName )! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 19:39'!
sistemaDeCambios
	^ sistemaDeCambios! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'Changes' stamp: 'SebastianGarbi 10/13/2013 18:44'!
superclassChangedOn: aClassName from: aSuperClassName to: aSuperClassName2
	self handle: (SuperclassChangedChange classAffected: aClassName oldSuperclass: aSuperClassName newSuperclass: aSuperClassName2).! !

Object subclass: #InterfazDeUsuario
	instanceVariableNames: 'sistemaDeCambios'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InterfazDeUsuario class methodsFor: 'as yet unclassified' stamp: 'Maxiii 9/30/2013 13:09'!
newWith: unSistemaDeCambios 
	^self new initializeWith: unSistemaDeCambios.! !

!InterfazDeUsuario methodsFor: 'as yet unclassified' stamp: 'Maxiii 9/30/2013 13:11'!
cerrarUnidad
	sistemaDeCambios cerrarUnidadDeTrabajoActiva.! !

!InterfazDeUsuario methodsFor: 'as yet unclassified' stamp: 'Maxiii 9/30/2013 13:09'!
initializeWith: unSistemaDeCambios 
	sistemaDeCambios := unSistemaDeCambios.! !

!InterfazDeUsuario methodsFor: 'as yet unclassified' stamp: 'Maxiii 9/30/2013 13:41'!
todosLosCambios
	^sistemaDeCambios todosLosCambios.! !

!InterfazDeUsuario methodsFor: 'as yet unclassified' stamp: 'Maxiii 9/30/2013 13:45'!
todosLosCambiosDelMensajeDeClase: aSelector deLaClase: aClass 
	^sistemaDeCambios historiaDelMetodoDeClase: aSelector deLaClase: aClass .! !

!InterfazDeUsuario methodsFor: 'as yet unclassified' stamp: 'Maxiii 9/30/2013 14:05'!
todosLosCambiosDelMensajeDeInstancia: aSelector deLaClase: aClass 
	^sistemaDeCambios historiaDelMetodoDeInstancia: aSelector deLaClase: aClass.! !

Object subclass: #InterfazParaLosAnuncios
	instanceVariableNames: 'systemAnnouncer interfazDeEntradaDelSistemaDeCambios'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InterfazParaLosAnuncios class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:48'!
newWith: anAnnouncer and: anInterfaceDeEntradaDelSistemaDeCambios 
	^self new initializeWith: anAnnouncer and: anInterfaceDeEntradaDelSistemaDeCambios.! !

!InterfazParaLosAnuncios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/30/2013 10:16'!
esDeClase: unaClase
	^ unaClase isKindOf: Metaclass! !

!InterfazParaLosAnuncios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/30/2013 18:39'!
handleInstanceVars: agregados inClass: affectedClassName for: anInstanceVariableChange
	agregados
		do: [ :anInstanceVar | 
			interfazDeEntradaDelSistemaDeCambios
				handle: (anInstanceVariableChange onClass: affectedClassName instanceVarAffected: anInstanceVar) ]! !

!InterfazParaLosAnuncios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/30/2013 10:03'!
initializeClassCategoryEvents
	systemAnnouncer
		on: CategoryRenamed
		do: [ :unEvento | 
			interfazDeEntradaDelSistemaDeCambios
				handle: (ClassCategoryRenamedChange from: unEvento oldCategoryName to: unEvento newCategoryName) ].
			
	systemAnnouncer
		on: CategoryAdded
		do: [ :unEvento | interfazDeEntradaDelSistemaDeCambios handle: (ClassCategoryCreatedChange newName: unEvento categoryName) ].
		
	systemAnnouncer
		on: CategoryRemoved
		do: [ :unEvento | interfazDeEntradaDelSistemaDeCambios handle: (ClassCategoryRemovedChange newName: unEvento categoryName) ]! !

!InterfazParaLosAnuncios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/30/2013 18:15'!
initializeClassEvents
	systemAnnouncer
		on: ClassAdded
		do: [ :unEvento | 
			interfazDeEntradaDelSistemaDeCambios
				handle: (ClassCreatedChange newAffectedClassName: unEvento classAdded name categoryName: unEvento classCategory) ].
	systemAnnouncer
		on: ClassRemoved
		do: [ :unEvento | 
			interfazDeEntradaDelSistemaDeCambios
				handle: (ClassRemovedChange newAffectedClassName: unEvento classRemoved name categoryName: unEvento categoryName) ].
	self initializeClassModifiedClassDefinition.
	systemAnnouncer
		on: ClassRecategorized
		do: [ :unEvento | 
			interfazDeEntradaDelSistemaDeCambios
				handle:
					(ClassRecategorizedChange classAffected: unEvento classAffected name from: unEvento oldCategory to: unEvento newCategory) ]! !

!InterfazParaLosAnuncios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/30/2013 19:08'!
initializeClassModifiedClassDefinition
	systemAnnouncer
		on: ClassModifiedClassDefinition
		do: [ :unEvento | 
			self registerSuperClassChangedChange: unEvento.
			"self registerInstanceVariableChange: unEvento" ]! !

!InterfazParaLosAnuncios methodsFor: 'as yet unclassified' stamp: 'Maxiii 9/30/2013 15:29'!
initializeMethodEvents
	systemAnnouncer
		on: MethodAdded
		do: [ :unEvento | 
			(self esDeClase: unEvento methodClass)
				ifTrue: [ 
					interfazDeEntradaDelSistemaDeCambios
						handle:
							(ClassMethodCreatedChange
								onClass: unEvento methodClass name
								selector: unEvento selector
								protocol: unEvento protocol
								sourceCode: unEvento method decompile printString) ]
				ifFalse: [ 
					interfazDeEntradaDelSistemaDeCambios
						handle:
							(InstanceMethodCreatedChange
								onClass: unEvento methodClass name
								selector: unEvento selector
								protocol: unEvento protocol
								sourceCode: unEvento method decompile printString) ] ].
	systemAnnouncer
		on: MethodRemoved
		do: [ :unEvento | 
			(self esDeClase: unEvento methodClass)
				ifTrue: [ 
					interfazDeEntradaDelSistemaDeCambios
						handle:
							(ClassMethodRemovedChange
								onClass: unEvento methodClass name
								selector: unEvento selector
								protocol: unEvento protocol
								sourceCode: unEvento methodRemoved decompile printString) ]
				ifFalse: [ 
					interfazDeEntradaDelSistemaDeCambios
						handle:
							(InstanceMethodRemovedChange
								onClass: unEvento methodClass name
								selector: unEvento selector
								protocol: unEvento protocol
								sourceCode: unEvento methodRemoved decompile printString) ] ].
	systemAnnouncer
		on: MethodRecategorized
		do: [ :unEvento | 
			(self esDeClase: unEvento methodClass)
				ifTrue: [ 
					interfazDeEntradaDelSistemaDeCambios
						handle:
							(ClassMethodCategoryRenamedChange
								newAffectedClassName: unEvento methodClass name
								withThisSelector: unEvento selector
								withThisMethod: unEvento methodRecategorized decompile printString
								fromThisCategory: unEvento oldProtocol
								toThisCategory: unEvento newProtocol) ]
				ifFalse: [ 
					interfazDeEntradaDelSistemaDeCambios
						handle:
							(InstanceMethodRecategorizedChange
								newAffectedClassName: unEvento methodClass name
								withThisSelector: unEvento selector
								withThisMethod: unEvento methodRecategorized decompile printString
								fromThisCategory: unEvento oldProtocol
								toThisCategory: unEvento newProtocol) ]	"Es un metodo de clase" ].
	systemAnnouncer
		on: MethodModified
		do: [ :unEvento | 
			(self esDeClase: unEvento methodClass)
				ifTrue: [ "Es un metodo de clase"
					interfazDeEntradaDelSistemaDeCambios
						handle: 
							(ClassMethodChangedChange 
								newAffectedClassName: unEvento methodClass name
								withThisSelector: unEvento selector
								fromThisMethod: unEvento oldMethod decompile printString
								toThisMethod: unEvento newMethod decompile printString
								fromThisCategory: unEvento oldProtocol
								toThisCategory: unEvento newProtocol ) ] 
				ifFalse: [ "Es un metodo de instancia"
					interfazDeEntradaDelSistemaDeCambios
						handle:
							(InstanceMethodChangedChange
								newAffectedClassName: unEvento methodClass name
								withThisSelector: unEvento selector
								fromThisMethod: unEvento oldMethod decompile printString
								toThisMethod: unEvento newMethod decompile printString
								fromThisCategory: unEvento oldProtocol
								toThisCategory: unEvento newProtocol ) ]							].! !

!InterfazParaLosAnuncios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/30/2013 10:05'!
initializeWith: anAnnouncer and: unaInterfaceDeEntradaDelSistemaDeCambios
	systemAnnouncer := anAnnouncer.
	interfazDeEntradaDelSistemaDeCambios := unaInterfaceDeEntradaDelSistemaDeCambios.

	self initializeClassEvents.
	self initializeMethodEvents.
	self initializeClassCategoryEvents.
	
! !

!InterfazParaLosAnuncios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/30/2013 18:43'!
registerInstanceVariableChange: unEvento
	| affectedClassName newInstanceVars agregados oldInstanceVars removidos |
	affectedClassName := unEvento classAffected name.
	oldInstanceVars := Set new.
	newInstanceVars := Set new.
	unEvento oldClassDefinition instanceVariableNamesDo: [ :aVariableName | oldInstanceVars add: aVariableName ].
	unEvento newClassDefinition instanceVariableNamesDo: [ :aVariableName | newInstanceVars add: aVariableName ].
	removidos := oldInstanceVars copy
		removeAll: newInstanceVars;
		yourself.
	agregados := newInstanceVars copy
		removeAll: oldInstanceVars;
		yourself.
	self handleInstanceVars: agregados inClass: affectedClassName for: InstanceVariableCreatedChange.
	self handleInstanceVars: removidos inClass: affectedClassName for: InstanceVariableRemovedChange.! !

!InterfazParaLosAnuncios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/30/2013 18:17'!
registerSuperClassChangedChange: unEvento
	| oldSuperclassName newSuperclassName |
	oldSuperclassName := unEvento oldClassDefinition superclass name.
	newSuperclassName := unEvento oldClassDefinition superclass name.
	oldSuperclassName ~= newSuperclassName
		ifTrue: [ 
			interfazDeEntradaDelSistemaDeCambios
				handle:
					(SuperclassChangedChange
						newAffectedClassName: unEvento newClassDefinition name
						oldSuperclassName: unEvento oldClassDefinition superclass name
						newSupeclassName: unEvento newClassDefinition superclass name) ]! !

Object subclass: #RegistroDeCambio
	instanceVariableNames: 'cambio autor fechaYHora'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!RegistroDeCambio class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:54'!
newWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora 
	^self new initializeWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora.! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:56'!
autor
	^ autor! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 18:04'!
cambio
	^ cambio! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:56'!
fechaYHora
	^ fechaYHora! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:58'!
initializeWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora 
	cambio := unCambio.
	autor := unNombreDeAutor.
	fechaYHora := unaFechaYHora.! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 19:18'!
tipoDeCambio
	^'classRemoved'.! !

Object subclass: #SistemaDeCambios
	instanceVariableNames: 'unidadesDeTrabajoCerradas unidadDeTrabajoActiva nuevoID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 10/8/2013 12:28'!
cerrarUnidadDeTrabajoActiva
	unidadDeTrabajoActiva cerrar.
	unidadesDeTrabajoCerradas at: nuevoID put: unidadDeTrabajoActiva.
	nuevoID := nuevoID + 1.
	^nuevoID! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/30/2013 11:35'!
historiaDelMetodoDeClase: aSelector deLaClase: aClass 
	^self todosLosCambios
		select: [ :unRegistroDeCambio | unRegistroDeCambio cambio esCambioDeMensajeDeClase: aSelector deLaClase: aClass ]! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/30/2013 11:01'!
historiaDelMetodoDeInstancia: aSelector deLaClase: aClass
	^ self todosLosCambios
		select: [ :unRegistroDeCambio | unRegistroDeCambio cambio esCambioDeMensajeDeInstancia: aSelector deLaClase: aClass ]! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 10/8/2013 12:22'!
initialize 
	unidadesDeTrabajoCerradas := Dictionary new.
	unidadDeTrabajoActiva := UnidadDeTrabajoInicial new.
	nuevoID := 0.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 10/8/2013 12:27'!
registrarCambio: unCambio
	| nuevaUnidadActiva |
	
	[ unidadDeTrabajoActiva registrarCambio: unCambio]
		on: UnidadDeTrabajoException
		do: [ nuevaUnidadActiva := UnidadDeTrabajoReal newWith: unidadDeTrabajoActiva.
		unidadDeTrabajoActiva := nuevaUnidadActiva.
		unidadDeTrabajoActiva registrarCambio: unCambio ].
! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 15:10'!
todosLosCambios
	^self unidadActiva todosLosCambios.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/16/2013 21:41'!
unidadActiva
	"devuelve la unidad de trabajo activa"
	^unidadDeTrabajoActiva.
	! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 20:43'!
unidadesDeTrabajo
	|todasLasUnidadesDeTrabajo|
	todasLasUnidadesDeTrabajo := unidadesDeTrabajoCerradas asSet.
	todasLasUnidadesDeTrabajo add: unidadDeTrabajoActiva.
	^todasLasUnidadesDeTrabajo.! !

Object subclass: #UnidadDeTrabajo
	instanceVariableNames: 'cambios cerrada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

UnidadDeTrabajo class
	instanceVariableNames: 'unidadActiva unidadesCerradas'!

UnidadDeTrabajo class
	instanceVariableNames: 'unidadActiva unidadesCerradas'!

!UnidadDeTrabajo class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
noSePuedeRegistrarCambios
	^'No se puede registrar cambios en esta unidad de trabajo.'.! !

!UnidadDeTrabajo class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 23:30'!
registrarCambio: unCambio
	| nuevaUnidadActiva |
	[ unidadActiva registrarCambio: unCambio]
	on: Error
	do: [ nuevaUnidadActiva := UnidadDeTrabajoReal newWith: unidadActiva.
		unidadesCerradas add: unidadActiva.
		unidadActiva := nuevaUnidadActiva.
		unidadActiva registrarCambio: unCambio ].
	^self
! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
cerrar
	cerrada := true.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
estaCerrada
	^cerrada.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'Maxii 9/30/2013 10:31'!
historiaCompletaDe: aSelector 
	self subclassResponsibility.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
initialize
	cambios := OrderedCollection new.
	cerrada := false.
	^self! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/28/2013 15:29'!
registrarCambio: unCambio
	self estaCerrada ifTrue: [ UnidadDeTrabajoException  signal: self class noSePuedeRegistrarCambios]. 
	cambios add: unCambio.
	^self.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 01:21'!
todosLosCambios
	self subclassResponsibility.! !

UnidadDeTrabajo subclass: #UnidadDeTrabajoInicial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!UnidadDeTrabajoInicial methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 01:22'!
todosLosCambios 
	^cambios copy.! !

UnidadDeTrabajo subclass: #UnidadDeTrabajoReal
	instanceVariableNames: 'padre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!UnidadDeTrabajoReal class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:38'!
newWith: unaUnidadDeTrabajo
	^self new initializeWith: unaUnidadDeTrabajo.! !

!UnidadDeTrabajoReal methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:39'!
initializeWith: unaUnidadDeTrabajo
	padre := unaUnidadDeTrabajo.
	^self.
	! !

!UnidadDeTrabajoReal methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:53'!
padre
	^ padre! !

!UnidadDeTrabajoReal methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/30/2013 01:45'!
todosLosCambios 
	^self padre todosLosCambios addAll: cambios;yourself.! !
